<?php

function invoice_api_settings_form() {
  $form = array();
  
  $form['invoice_api_number'] = array(
    '#type' => 'fieldset',
    '#title' => t('Invoice number generation'),
    '#description' => t('This determines the way the invoice numbers are generated.')
  );
  
  $methods = module_invoke_all('invoice_api_info');
  
  foreach($methods as $key => $method) {
    if(isset($method['number']) && $method['number'] == TRUE) {
      $form['invoice_api_number'][$key] = array(
        '#type' => 'radio',
        '#title' => $method['title'],
        '#description' => $method['description'],
        '#return_value' => $key,
        '#default_value' => (variable_get('invoice_api_number', '') == $key) ? $key : 0,
        '#parents' => array('invoice_api_number'),    
      );      
    }
  } 
  
  $form['invoice_api_invoice'] = array(
    '#type' => 'fieldset',
    '#title' => t('Invoice generation method'),
    '#description' => t('This determines the way the invoices are generated.')
  );
  
  foreach($methods as $key => $method) {
    if(isset($method['invoice']) && $method['invoice'] == TRUE) {
      $form['invoice_api_invoice']['invoice_api_invoice_method'] = array(
        '#type' => 'radio',
        '#title' => t('Invoice generation method'),
        '#description' => t('This determines the way the invoices are generated.'),
        '#parents' => array('invoice_api_invoice'),
      );
    }
  }
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );
  
  return $form;
}

function invoice_api_settings_form_submit($form, &$form_state) {
  variable_set('invoice_api_number', $form_state['values']['invoice_api_number']);
}

function invoice_api_number_settings() {
  $output = '';
  
  $infos = module_invoke_all('invoice_api_info');
  if(isset($infos[variable_get('invoice_api_number', '')]) && $method = $infos[variable_get('invoice_api_number', '')]) {
    $form = drupal_get_form($method['number settings']);
    $output .= drupal_render($form);
  }
  
  return $output;
}

function invoice_api_invoice_settings() {
  $output = '';
  
  $infos = module_invoke_all('invoice_api_info');
  if(isset($infos[variable_get('invoice_api_invoice', '')]) && $method = $infos[variable_get('invoice_api_invoice', '')]) {
    $form = drupal_get_form($method['invoice settings']);
    $output .= drupal_render($form);
  } else {
    $output .= t('No method for generating invoices selected.');
  }
  
  return $output;
}