<?php

/**
 * @file
 * Rules integration for invoices.
 *
 * @addtogroup rules
 * @{
 */

/**
 * Implements hook_rules_condition_info()
 */
function invoice_api_rules_condition_info() {
  $items = array();
  $items['invoice_api_exists'] = array(
    'label' => t('Invoice exists for Order'),
    'parameter' => array(
      'commerce_order' => array(
        'type' => 'commerce_order',
        'label' => t('Order to check'),
      ),
    ),
    'group' => t('Commerce Invoice'),
    'callbacks' => array(
      'execute' => 'invoice_api_rules_condition_exists'
    )
  );
  return $items;
}

function invoice_api_rules_condition_exists($order) {
  $order_id = $order->order_id;
  $query = new EntityFieldQuery();
  $results = $query
    ->entityCondition('entity_type', 'invoice_api')
    ->propertyCondition('order_id', $order_id, '=')
    ->execute();
  if(isset($results['invoice_api'])) {
    return TRUE;
  }
  else {
    return FALSE;
  }
}
 
/**
 * Implements hook_rules_action_info().
 */
function invoice_api_rules_action_info() {
  $actions = array();

  $actions['invoice_api_generate'] = array(
    'label' => t('Generate invoice'),
    'parameter' => array(
      'commerce_order' => array(
        'type' => 'commerce_order',
        'label' => t('Order to update'),
      ),
    ),
    'group' => t('Invoice API'),
    'callbacks' => array(
      'execute' => 'invoice_api_rules_generate',
    ),
  );
  
  return $actions;
}

function invoice_api_rules_generate($order) {
  dpm($order);
  $invoice = invoice_api_new($order->uid, $order->order_id);
  invoice_api_save($invoice);
}